#include <stdio.h>
#include <stdlib.h>
#include "mathlib.h"
#include "sph_cap.h"
#include "calcChar.h"
#include "ACHAIMDB.h"
#include "ACHAIM_Chars.h"
#include "ECHAIM_Chars.h"

//****DEBUGGING************
#ifdef DBG
#include "memwatch.h"
#endif
//*************************

//Example script for ACHAIM_Chars.c
//Running this in the same directory as example.db will
//generate example output which can be compared with example.dat to ensure
//your install of ACHAIM_Chars is correct

int main()
{
	//Setting inputs
	double lat[2] = {70,80}, lon[2] = {120,130}, alt[2] = {300,300};
	int nLat = 2;
	char dbFile[32] = "example.db";
	double *output;
	
	char names[7][5] = {"nmf2","hmf2","hbot","htop","hf1","he","hmf1"}; //Characteristics to calculate
	
	printf("A-CHAIM:\n");
	for (int i=0; i<7; i++)
	{
		printf("%s: ", names[i]); //Print name of characteristic being calculated
		output = AC_Char(names[i], lat, lon, nLat, dbFile); //calculate the charactieristic

		//Loop through the output and print the values
		for (int i=0; i<nLat; i++)
		{
			printf("%f ",output[i]);
		}
		printf("\n");
		free(output);
	}
	
	//Calculate and print the density
	printf("dens: ");
	output = AC_Dens(lat, lon, alt, nLat, dbFile);
	for (int i=0; i<nLat; i++)
	{
		printf("%f ",output[i]);
	}
	printf("\n");
	
	//Calculate and print the TEC
	printf("TEC: ");
	output = AC_TEC(lat, lon, nLat, dbFile);
	for (int i=0; i<nLat; i++)
	{
		printf("%f ",output[i]);
	}
	printf("\n");
	
	printf("E-CHAIM:\n");
	for (int i=0; i<7; i++)
	{
		printf("%s: ", names[i]); //Print name of characteristic being calculated
		output = EC_Char(names[i], lat, lon, nLat, dbFile); //calculate the charactieristic

		//Loop through the output and print the values
		for (int i=0; i<nLat; i++)
		{
			printf("%f ",output[i]);
		}
		printf("\n");
		free(output);
	}
	
	//Calculate and print the density
	printf("dens: ");
	output = EC_Dens(lat, lon, alt, nLat, dbFile);
	for (int i=0; i<nLat; i++)
	{
		printf("%f ",output[i]);
	}
	printf("\n");
	
	//Calculate and print the TEC
	printf("TEC: ");
	output = EC_TEC(lat, lon, nLat, dbFile);
	for (int i=0; i<nLat; i++)
	{
		printf("%f ",output[i]);
	}
	printf("\n");
	
	free(output);
	
}