#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "calcChar.h"

//****DEBUGGING************
#ifdef DBG
#include "memwatch.h"
#endif
//*************************

//Generate characterstics using specific calculation type
//Input:
//basis = basis set matrix (double **)
//lx = length of matrices first dimension (int)
//ly = length of matrices second dimension (int)
//params = model parameters array (double *)
//lp = length of parameters array (int)
//modelParams = model parameters (double *)
// lmp = length of model parameters (int)

//logadd
double *logAdd(double **basis, int lx, int ly, double * params, int lp, double *modelParams, int lmp)
{
	//declare variables
	double matPar, matModPar; //temp variables for matrix multiplication
	static double *output; //output will be an lx length vector
	
	output = calloc(lx, sizeof(double));

	//Do the matrix multiplication and calculate the output
	for (int x=0; x<lx; x++)
	{
		matPar = 0;
		matModPar = 0;
		
		for (int y=0; y<ly; y++)
		{
			if (y < lp) {matPar += basis[x][y] * params[y];}
			if (y < lmp) {matModPar += basis[x][y] * modelParams[y];}
			
		}
		
		output[x] = exp(matPar + log(matModPar));
	}

	return output;
	
}

//static
double *stat(double **basis, int lx, int ly, double *modelParams, int lmp)
{
	//declare variables
	double matModPar; //temp variables for matrix multiplication
	static double *output; //output will be an lx length vector
	
	output = calloc(lx, sizeof(double));
	
	//Do the matrix multiplication and calculate the output
	for (int x=0; x<lx; x++)
	{
		matModPar = 0;
		
		for (int y=0; y<ly; y++)
		{
			matModPar += basis[x][y] * modelParams[y];
		}
		
		output[x] = matModPar;
	}
	
	return output;
	
}